<script setup lang="ts">
import { Bar } from 'vue-chartjs'
import { BarElement, CategoryScale, Chart as ChartJS, Legend, LinearScale, Tooltip } from 'chart.js'

const {
  labels,
  data,
  title,
} = defineProps<{
  labels: string[]
  data: number[]
  title: string
}>()
const labelNew = labels.map((item): string => {
  if (item.length > 10)
    return `${item.slice(0, 10)}...`
  else
    return item
})

ChartJS.register(Tooltip, Legend, BarElement, CategoryScale, LinearScale)
</script>

<template>
  <Bar
    :chart-options="{
      responsive: true,
      indexAxis: 'y',
      plugins: {
        legend: {
          position: 'top',
          display: false,
        },
        title: {
          display: false,
          text: 'Chart.js Line Chart',
        },
      },
      scale: {
        ticks: {
          precision: 0,
        },
      },
    }"
    :chart-data="{
      labels: labelNew,
      datasets: [
        {
          label: title,
          data,
          backgroundColor: ['RGB(129, 211, 211)', 'RGB(214, 65, 141)', 'RGB(255, 145, 169)', 'RGB(255, 221, 136)'],
        },
      ],
    }"
    :height="300"
    chart-id="chartId"
    dataset-id-key="datasetIdKey"
  />
</template>

<style scoped></style>
